# SKA Monitoring Collection

This collection includes a variety of Ansible roles to help automate the installation and configuration of the monitoring stack: [Prometheus](https://prometheus.io/) + [Thanos](https://thanos.io/) and [Grafana](https://grafana.com/).
This collection is currently maintained by [SKAO](https://www.skao.int/).

## Ansible

Tested with the current Ansible 6.5.x releases.

## Ansible Roles
| Name | Description |
| ---- | ----------- |
| [monitoring.alertmanager](./roles/alertmanager) | Installs the [Alert Manager](https://prometheus.io/docs/alerting/latest/alertmanager/) |
| [monitoring.custom_metrics](.roles/custom_metrics) | Adds custom metrics exporter as cron job |
| [monitoring.grafana](.roles/grafana) | Install [Grafana](https://grafana.com/grafana/) |
| [monitoring.node_exporter](./roles/node_exporter) | Installs the [prometheus node exporter](https://github.com/prometheus/node_exporter) |
| [monitoring.prometheus](./roles/prometheus) | Installs [Prometheus](https://prometheus.io/) |
| [monitoring.thanos](./roles/thanos) | Installs [Thanos](https://thanos.io/) components |
| [monitoring.ironic_exporter](./roles/ironic_exporter) | Deploys [ironic_exporter](https://gitlab.com/piersharding/openstack-exporter.git) |
| [monitoring.apt_exporter](./roles/apt_exporter) | Deploys [apt_exporter](https://gitlab.com/ska-telescope/sdi/ska-software-updates-notifier) |
| [monitoring.slurm_exporter](./roles/slurm_exporter) | Deploys [slurm_exporter](https://github.com/vpenso/prometheus-slurm-exporter) |



## Installation

Before using the collection, you need to install the collection with the `ansible-galaxy` CLI:

    ansible-galaxy collection install ska_collections.monitoring

You can also include it in a `requirements.yml` file and install it via ansible-galaxy collection install -r requirements.yml` using the format:

```yaml
collections:
- name: ska_collections.monitoring
```

## Usage

Playbooks can be found in the [playbooks/](./playbooks) folder in the following files:

| Name | Description |
| ---- | ----------- |
| [deploy_alertmanager.yml](./playbooks/deploy_alertmanager.yml) | Deploys  [Alert Manager](https://prometheus.io/docs/alerting/latest/alertmanager/) |
| [deploy_grafana.yml](./playbooks/deploy_grafana.yml) | Installs [Grafana](https://grafana.com/grafana/) and optionally [Grafana Oncall](https://github.com/grafana/oncall) |
| [deploy_node_exporter.yml](./playbooks/deploy_node_exporter.yml) | Deploys [prometheus node exporter](https://github.com/prometheus/node_exporter) |
| [deploy_prometheus.yml](./playbooks/deploy_prometheus.yml) | Deploys [Prometheus](https://prometheus.io/) |
| [deploy_thanos.yml](./playbooks/deploy_thanos.yml) | Deploys [Thanos](https://thanos.io/) |
| [deploy_ironic_exporter.yml](./playbooks/deploy_ironic_exporter.yml) | Deploys [ironic_exporter](https://gitlab.com/piersharding/openstack-exporter.git) |
| [deploy_slurm_exporter.yml](./playbooks/deploy_slurm_exporter.yml) | Deploys [slurm_exporter](https://github.com/vpenso/prometheus-slurm-exporter) |
| [deploy_apt_exporter.yml](./playbooks/deploy_apt_exporter.yml) | Deploys [apt_exporter](https://gitlab.com/ska-telescope/sdi/ska-software-updates-notifier) |
| [destroy_apt_exporter.yml](./playbooks/destroy_apt_exporter.yml) | Destroys [apt_exporter](https://gitlab.com/ska-telescope/sdi/ska-software-updates-notifier) |
| [generate_targets.yml](./playbooks/generate_targets.yml) | Generates Prometheus targets |

### Generate Prometheus Targets

Firstly before deploying the prometheus service you need to generate the target configuration so it can get all the instances that are producing metrics (node-exporter, docker-exporter, cadvisor...). For this you need to run the following playbook:

```
ansible-playbook <playbooks-folder-path>/generate_targets.yml \
	-i <inventory_file> \
	--extra-vars "target_hosts=<target-hosts>"
```

This will use the Env Variables ***DATACENTRE*** and ***ENVIRONMENT*** to fetch the inventory from there so it can loop over those machines and check which ones are producing metrics. This will populate the files in the [files folder](./monitoring/roles/prometheus/files/).
This playbook will against the machine passed to target_hosts where it will install poetry if not there already and create a virtual environment.

In order to run these playbooks, it's needed to specify the Ansible Inventory location and the respective group/hosts ***target_hosts*** variable.

Run **deploy_monitoring** playbook as an example:
```
ansible-playbook <playbooks-folder-path>/deploy_prometheus.yml \
	-i <inventory_file> \
	--extra-vars "target_hosts=<target-hosts>"
```

### Variables and secrets

This collection requires some variables to be set to properly work. Almost all of them can be set in a yaml file and passed to the playbook but some of them contains secrets that must be passed in a different way. In specific the mandatory variables are:

- *alertmanager_default_slack_api_url*: for infrastructure alert message sent via slack;
- *alertmanager_match_slack_api_url*: for regex matched alert messages sent via slack;
- *alertmanager_global_health_slack_api_url*: for the global health alerts, across the multiple clusters, sent via slack;
- *alertmanager_global_health_oncall_webhook_url*: for the global health alerts, accross the multiple clusters, sent via Grafana Oncall;
- *ca_cert_password*: for CA certificate signing;
- *thanos_swift_server_auth_url*: for swift storage;
- *thanos_swift_server_username*: for swift storage;
- *thanos_swift_server_password*: for swift storage (base 64 encoded);
- *prometheus_gitlab_ci_pipelines_exporter_token*: for gitlab related metrics;
- *grafana_azuread_tenant_id*: for grafana authentication with Azure;
- *grafana_azuread_client_secret*: for grafana authentication with Azure;
- *grafana_azuread_client_id*: for grafana authentication with Azure;

The **deploy_grafana** playbook can also deploy [Grafana Oncall](https://github.com/grafana/oncall) if `grafana_oncall_enabled` is set to `true`.  In this scenario the following additional secret variables are needed:

- *grafana_oncall_secret_key*: secret key for Grafana Oncall (use not documented - needs to be at least 32 bytes long)
- *grafana_oncall_mirage_secret_key*: for encrypting data with mirage (needs to be at least 32 bytes long)
- *grafana_oncall_mirage_cipher_iv*: for encrypting data with mirage (needs to be 16 bytes long exactly)
- *grafana_oncall_prometheus_exporter_enabled*: for enabling / disabling the prometheus exporter `/metrics/` endpoint for Grafana Oncall
- *grafana_oncall_prometheus_secret*: Grafana Oncall prometheus secret key - only required if enabled above
- *grafana_oncall_slack_integration_enabled*: for enabling / disabling the oncall slack integration
- *grafana_oncall_slack_client_oauth_id*: Slack integration app Client ID - only required if oncall slack integration is enabled
- *grafana_oncall_slack_client_oauth_secret*: Slack integration app Client Secret - only required if oncall slack integration is enabled
- *grafana_oncall_slack_signing_secret*: Slack integration app Signing Secret - only required if oncall slack integration is enabled

Using the makefile provided with the current repository, the secrets variables correspond to the following environment variables:

| Ansible variable | ENV variable |
| ---------------- | ------------ |
| alertmanager_default_slack_api_url | ALERTMANAGER_DEFAULT_SLACK_API_URL |
| alertmanager_match_slack_api_url | ALERTMANAGER_MATCH_SLACK_API_URL |
| ca_cert_password | CA_CERT_PASSWORD |
| thanos_swift_server_password | THANOS_OS_PASSWORD |
| prometheus_gitlab_ci_pipelines_exporter_token | GITLAB_TOKEN |
| grafana_azuread_client_secret | AZUREAD_CLIENT_SECRET |
| grafana_azuread_client_id | AZUREAD_CLIENT_ID |
| grafana_azuread_tenant_id | AZUREAD_TENANT_ID |
| grafana_oncall_secret_key | SECRET_KEY |
| grafana_oncall_mirage_secret_key | MIRAGE_SECRET_KEY |
| grafana_oncall_mirage_cipher_iv | MIRAGE_CIPHER_IV |
| grafana_oncall_prometheus_exporter_enabled | FEATURE_PROMETHEUS_EXPORTER_ENABLED |
| grafana_oncall_slack_integration_enabled | FEATURE_SLACK_INTEGRATION_ENABLED |
| grafana_oncall_prometheus_secret | GRAFANA_ONCALL_PROMETHUS_SECRET |
| grafana_oncall_slack_client_oauth_id | SLACK_CLIENT_OAUTH_ID |
| grafana_oncall_slack_client_oauth_secret | SLACK_CLIENT_OAUTH_SECRET |
| grafana_oncall_slack_install_return_redirect_host | SLACK_INSTALL_RETURN_REDIRECT_HOST |
| grafana_oncall_slack_signing_secret | SLACK_SIGNING_SECRET |

